/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-moveit-simple-grasps-1.1.0-0quantal-20150519-1009/msg/GraspGeneratorOptions.msg
 *
 */


#ifndef MOVEIT_SIMPLE_GRASPS_MESSAGE_GRASPGENERATOROPTIONS_H
#define MOVEIT_SIMPLE_GRASPS_MESSAGE_GRASPGENERATOROPTIONS_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace moveit_simple_grasps
{
template <class ContainerAllocator>
struct GraspGeneratorOptions_
{
  typedef GraspGeneratorOptions_<ContainerAllocator> Type;

  GraspGeneratorOptions_()
    : grasp_axis(0)
    , grasp_direction(0)
    , grasp_rotation(0)  {
    }
  GraspGeneratorOptions_(const ContainerAllocator& _alloc)
    : grasp_axis(0)
    , grasp_direction(0)
    , grasp_rotation(0)  {
    }



   typedef uint8_t _grasp_axis_type;
  _grasp_axis_type grasp_axis;

   typedef uint8_t _grasp_direction_type;
  _grasp_direction_type grasp_direction;

   typedef uint8_t _grasp_rotation_type;
  _grasp_rotation_type grasp_rotation;


    enum { GRASP_AXIS_X = 0 };
     enum { GRASP_AXIS_Y = 1 };
     enum { GRASP_AXIS_Z = 2 };
     enum { GRASP_DIRECTION_UP = 0 };
     enum { GRASP_DIRECTION_DOWN = 1 };
     enum { GRASP_ROTATION_HALF = 0 };
     enum { GRASP_ROTATION_FULL = 1 };
 

  typedef boost::shared_ptr< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct GraspGeneratorOptions_

typedef ::moveit_simple_grasps::GraspGeneratorOptions_<std::allocator<void> > GraspGeneratorOptions;

typedef boost::shared_ptr< ::moveit_simple_grasps::GraspGeneratorOptions > GraspGeneratorOptionsPtr;
typedef boost::shared_ptr< ::moveit_simple_grasps::GraspGeneratorOptions const> GraspGeneratorOptionsConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace moveit_simple_grasps

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'shape_msgs': ['/opt/ros/hydro/share/shape_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/hydro/share/sensor_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/hydro/share/trajectory_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'object_recognition_msgs': ['/opt/ros/hydro/share/object_recognition_msgs/cmake/../msg'], 'octomap_msgs': ['/opt/ros/hydro/share/octomap_msgs/cmake/../msg'], 'moveit_simple_grasps': ['/tmp/buildd/ros-hydro-moveit-simple-grasps-1.1.0-0quantal-20150519-1009/msg', '/tmp/buildd/ros-hydro-moveit-simple-grasps-1.1.0-0quantal-20150519-1009/obj-x86_64-linux-gnu/devel/share/moveit_simple_grasps/msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'moveit_msgs': ['/opt/ros/hydro/share/moveit_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> >
{
  static const char* value()
  {
    return "99863eab001728611523218e2a9810a3";
  }

  static const char* value(const ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x99863eab00172861ULL;
  static const uint64_t static_value2 = 0x1523218e2a9810a3ULL;
};

template<class ContainerAllocator>
struct DataType< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> >
{
  static const char* value()
  {
    return "moveit_simple_grasps/GraspGeneratorOptions";
  }

  static const char* value(const ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> >
{
  static const char* value()
  {
    return "uint8 grasp_axis\n\
uint8 GRASP_AXIS_X = 0\n\
uint8 GRASP_AXIS_Y = 1\n\
uint8 GRASP_AXIS_Z = 2\n\
\n\
uint8 grasp_direction\n\
uint8 GRASP_DIRECTION_UP = 0\n\
uint8 GRASP_DIRECTION_DOWN = 1\n\
\n\
uint8 grasp_rotation\n\
uint8 GRASP_ROTATION_HALF = 0\n\
uint8 GRASP_ROTATION_FULL = 1\n\
";
  }

  static const char* value(const ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.grasp_axis);
      stream.next(m.grasp_direction);
      stream.next(m.grasp_rotation);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct GraspGeneratorOptions_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::moveit_simple_grasps::GraspGeneratorOptions_<ContainerAllocator>& v)
  {
    s << indent << "grasp_axis: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.grasp_axis);
    s << indent << "grasp_direction: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.grasp_direction);
    s << indent << "grasp_rotation: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.grasp_rotation);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MOVEIT_SIMPLE_GRASPS_MESSAGE_GRASPGENERATOROPTIONS_H
